; SUB device 0.06 by Phil Borman
;
; Disassembly by Marcel Kilgus

	section sub

	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_qdos_ioa'
	include 'dev8_keys_qdos_io'
	include 'dev8_keys_iod'
	include 'dev8_keys_err'
	include 'dev8_keys_qlv'
	include 'dev8_keys_sbasic'
	include 'dev8_keys_hdr'
	include 'dev8_keys_sys'
	include 'dev8_keys_chn'

ddb_iod equ    $000			; device driver linkage block
ddb_drv equ    $048			; 6 bytes  SUB_DRV name
ddb_num equ    $04e			; 1 byte   SUB_DRV number
ddb.drx equ    38			; length of drive name
ddb_dr1 equ    $050			; 38 bytes SUB_USE drive 1
ddb_dr2 equ    $076			; 38 bytes SUB_USE drive 2
ddb_dr3 equ    $09c			; 38 bytes SUB_USE drive 3
ddb_dr4 equ    $0c2			; 38 bytes SUB_USE drive 4
ddb_dr5 equ    $0e8			; 38 bytes SUB_USE drive 5
ddb_dr6 equ    $10e			; 38 bytes SUB_USE drive 6
ddb_dr7 equ    $134			; 38 bytes SUB_USE drive 7
ddb_dr8 equ    $15a			; 38 bytes SUB_USE drive 8
ddb_len equ    $180

; Physical definition block
phys.len equ	$28

; Channel definition block
sub_cid equ	$58			; Real channel ID
sub_num equ	$5c			; SUB drive number
sub_dir equ	$5d			; Real channel was to directory
sub_nml equ	$5e			; Real channel name length
sub_nam equ	$60			; Real channel name

start	move.l	#ddb_len,d1
	moveq	#sms.achp,d0
	moveq	#0,d2
	trap	#1
	lea	iod_ioad(a0),a3
	lea	io(pc),a2
	move.l	a2,(a3)+		; iod_ioad: I/O routine
	lea	open(pc),a2
	move.l	a2,(a3)+		; iod_open: open routine
	lea	close(pc),a2
	move.l	a2,(a3)+		; iod_clos: close routine
	clr.l	(a3)+			; iod_fslv
	addq.l	#8,a3
	lea	format(pc),a2
	move.l	a2,(a3)+		; iod_frmt: format routine
	move.l	#phys.len,(a3)+

	lea	L0896(pc),a2
	move.w	(a2)+,(a3)+		; iod_dnus: Drive name (current usage)
	move.l	(a2),(a3)+
	move.b	#'0',-1(a3)
	move.w	#3,(a3)+

	move.l	#'SUB0',(a3)+		; iod_dnam: Drive name

	lea	cf_drv(pc),a2		; configured SUB_DRV name
	move.w	(a2)+,(a3)+
	move.l	(a2),(a3)+

	lea	cf_num(pc),a2		; configured SUB_DRV number
	move.b	(a2),(a3)+
	move.b	#0,(a3)+

	lea	cf_drv1(pc),a2
	bsr.s	cpy_use_name
	lea	cf_drv2(pc),a2
	bsr.s	cpy_use_name
	lea	cf_drv3(pc),a2
	bsr.s	cpy_use_name
	lea	cf_drv4(pc),a2
	bsr.s	cpy_use_name
	lea	cf_drv5(pc),a2
	bsr.s	cpy_use_name
	lea	cf_drv6(pc),a2
	bsr.s	cpy_use_name
	lea	cf_drv7(pc),a2
	bsr.s	cpy_use_name
	lea	cf_drv8(pc),a2
	bsr.s	cpy_use_name
	bra.s	link_driver

cpy_use_name
	move.w	#18,d1			; 36+2 characters
	lea	2(a2),a2
cpy_use_loop
	move.w	(a2)+,(a3)+
	dbf	d1,cpy_use_loop
	rts

link_driver
	movea.l a0,a3
	lea	iod_iolk(a3),a0
	moveq	#sms.lfsd,d0
	trap	#1
	lea	procs(pc),a1
	movea.w sb.inipr,a2
	jsr	(a2)
	moveq	#0,d0
	rts

procs	dc.w	2
	dc.w	sub_use-*
	dc.b	7,'SUB_USE'
	dc.w	sub_drv-*
	dc.b	7,'SUB_DRV'
	dc.w	0
	dc.w	2
	dc.w	sub_use$-*
	dc.b	8,'SUB_USE$',0
	dc.w	sub_drv$-*
	dc.b	8,'SUB_DRV$',0
	dc.w	0

;	BASIC - Procedure 'SUB_DRV'
sub_drv bsr	ut_gtnam
	  bne	ret_ipar
	move.w	(a6,a1.l),d7
	cmpi.w	#4,d7
	  bne	ret_ipar
	move.l	2(a6,a1.l),d7
	subi.b	#'0',d7
	cmpi.b	#1,d7
	  bcs	ret_ipar
	cmpi.b	#8,d7
	  bhi	ret_ipar
	andi.l	#$DFDFDFFF,d7
	bsr	get_ddb
	tst.l	d0
	  bne.s L0132
	move.b	d7,ddb_num(a3)
	move.l	d7,ddb_drv+2(a3)
	move.b	#'0',ddb_drv+5(a3)
L0132	rts

;	BASIC - Procedure 'SUB_USE'
sub_use moveq	#0,d7			; Get driver name in get_use$
	cmpa.l	a3,a5
	  bne.s use_param
	bsr	get_use$
	move.l	8(a4),2(a4)		; Restore original SUB name
	bra.s	use_rts

use_param
	bsr.s	use_getpar
	move.w	(a6,a1.l),d5
	lea	2(a1),a1
	cmp.w	d4,d5
	  bhi.s ret_ipar
	cmpi.w	#0,d7
	  bne.s L016E
	move.l	(a6,a1.l),d5
	andi.l	#$DFDFDF00,d5
	move.b	#'0',d5
	move.l	d5,2(a4)
	bra.s	use_rts
L016E	move.w	d5,d4
	movea.l a4,a0
	move.w	d5,(a4)+
	bra.s	L017E
L0176	move.b	(a6,a1.l),(a4)+
	lea	1(a1),a1
L017E	dbf	d5,L0176
	cmpi.b	#'_',-1(a4)
	  beq.s use_rts
	cmpi.w	#0,d4
	  beq.s use_rts
	move.b	#'_',(a4)
	addq.w	#1,d4
	move.w	d4,(a0)
use_rts moveq	#0,d0
	rts

ret_ipar
	moveq	#err.ipar,d0
	rts

use_getpar
	lea	2*8(a3),a4		; two parameter?
	cmpa.l	a4,a5
	  beq.s L01B4			; ... yes
	lea	8(a3),a4		; one parameter?
	cmpa.l	a4,a5
	  bne.s use_ipar4		; ... no
	moveq	#0,d7
	bra.s	L01CA

L01B4	subq.l	#8,a5
	movea.w sb.gtint,a2
	jsr	(a2)
	cmpi.w	#1,d3
	  bne.s use_ipar4
	move.w	(a6,a1.l),d7
	movea.l a5,a3
	movea.l a4,a5
L01CA	bsr	ut_gtnam		; get name

; d7 = 0 for DNUS, d7 = drive for SUB_USE string
get_use$
	bsr	get_ddb
	tst.l	d0
	  bne.s use_ipar4
	tst.b	d7
	  bne.s L01E2
	moveq	#3,d4
	lea	iod_dnus(a3),a4
	rts

L01E2	moveq	#0,d4
	move.b	d7,d4
	bsr	get_use_name
	tst.l	d0
	  bne.s use_ipar4
	moveq	#hdr.nmln,d4
	rts

use_ipar4
	moveq	#err.ipar,d0
	lea	4(a7),a7
	rts

;	BASIC - Function  'SUB_USE$'
sub_use$
	lea	8(a3),a4
	cmpa.l	a4,a5
	  beq.s use$_par1
	cmpa.l	a3,a5
	  bne.s ret_ipar
	moveq	#0,d7			; get driver name
	bra.s	L021E

use$_par1
	movea.w sb.gtint,a2
	jsr	(a2)
	cmpi.w	#1,d3
	  bne.s ret_ipar
	move.w	0(a6,a1.l),d7		; get SUB_USE string for this drive
	addq.l	#2,sb_arthp(a6) 	; Remove int

L021E	bsr.s	get_use$
	tst.l	d0
	  bne.s use$_rts
	move.w	(a4),d4
	addq.w	#2,d4
	ext.l	d4
	move.l	d4,d1
	movea.w qa.resri,a2
	jsr	(a2)
	movea.l sb_arthp(a6),a1
	move.w	(a4)+,d4
	suba.l	d4,a1
	subq.l	#2,a1
	btst	#0,d4
	  beq.s L0244
	subq.l	#1,a1
L0244	move.l	a1,sb_arthp(a6)
	move.w	d4,(a6,a1.l)
	lea	2(a1),a1
	bra.s	L025A

L0252	move.b	(a4)+,(a6,a1.l)
	lea	1(a1),a1
L025A	dbf	d4,L0252
	movea.l sb_arthp(a6),a1
	moveq	#1,d4
	moveq	#0,d0
use$_rts
	rts

; Get our own driver definition block
get_ddb moveq	#sms.info,d0
	trap	#1
	move.l	#'SUB0',d1
	lea	sys_fsdl(a0),a0
ddb_loop
	cmp.l	iod_dnam-iod_iolk+2(a0),d1
	  beq.s ddb_rts
	movea.l (a0),a0
	move.l	a0,d2
	  bne.s ddb_loop
	moveq	#err.fdnf,d0
ddb_rts lea	-iod_iolk(a0),a3
	rts

;	BASIC - Function  'SUB_DRV$'
sub_drv$
	bsr.s	get_ddb
	tst.l	d0
	  bne.s sd$_rts
	move.l	ddb_drv+2(a3),d7
	move.b	ddb_num(a3),d7
	addi.b	#'0',d7
	moveq	#6,d4
	move.l	d4,d1
	movea.w qa.resri,a2
	jsr	(a2)
	movea.l sb_arthp(a6),a1
	suba.l	d4,a1
	move.l	a1,sb_arthp(a6)
	move.w	#4,(a6,a1.l)
	move.l	d7,2(a6,a1.l)
	moveq	#1,d4
	moveq	#0,d0
sd$_rts rts

; Search for our SUB driver. Not used?
	lea	sys_fsdl(a6),a0
fs_loop
	cmp.l	iod_dnus-iod_iolk+2(a0),d1
	  bne.s fs_next
	cmpi.l	#'SUB0',iod_dnam-iod_iolk+2(a0)
	  bne.s ret_ok
fs_next movea.l (a0),a0
	move.l	a0,d2
	  bne.s fs_loop
fs_ipar
	moveq	#err.ipar,d0
	rts

ret_ok	moveq	#0,d0
	rts

; Scan physical definition blocks. Not used?
	move.l	a0,d3
	lea	sys_fsdd(a6),a0
	moveq	#sys.nfsd,d0
	move.b	d4,d1			; drive number
	moveq	#0,d4			; slot number in sys_fsdd
	bra.s	pdb_start

pdb_loop
	movea.l (a0),a1
	lea	iod_drlk(a1),a2 	; pointer to driver linkage
	movea.l (a2),a2
	cmp.l	a2,d3			; is this us?
	  bne.s pdb_next		; no
	lea	iod_dnum(a1),a2
	cmp.b	(a2),d1 		; drive number matches?
	  beq.s ret_ok
pdb_next
	lea	4(a0),a0
	addq.b	#1,d4
pdb_start
	dbf	d0,pdb_loop
	bra.s	fs_ipar

; ***** I/O routine
io	cmpi.b	#iof.rnam,d0
	  bne.s io_rest
	bsr.s	get_rename_name
	tst.l	d0
	  bge.s io_rest
	rts

io_rest move.l	d3,-(a7)
	movem.l d0/a0,-(a7)
	movea.l sub_cid(a0),a0
	trap	#3			; call real I/O
	movem.l (a7)+,d3/a0		; D3 = trap key
	tst.l	d0
	  bne.s io_rts
	tst.b	sub_dir(a0)		; file is directory?
	  beq.s io_rts			; no, we're done here
	cmpi.b	#iob.fmul,d3
	  bne.s io_rts
	cmpi.w	#hdr.len,d2
	  bne.s io_rts

; Fix directory entry
	lea	hdr_name-hdr.len(a1),a2
	move.b	sub_num(a0),d4
	bsr	get_use_name
	tst.w	(a4)
	  beq.s io_rts
	movea.l a2,a3			; original name
	move.w	(a3)+,d2		; original name length
	move.w	(a4)+,d4		; SUB_USE name length
	move.w	d4,d3
	subq.w	#1,d3
	cmp.w	d4,d2
	  ble.s fix_err 		; original < sub length? Shouldn't happen

; Start of original name must match substituted name
	moveq	#0,d6
	moveq	#0,d5
fix_chk_loop
	move.b	(a4)+,d6
	andi.b	#$DF,d6
	move.b	(a3)+,d5
	andi.b	#$DF,d5
	cmp.b	d5,d6
	  bne.s fix_err
	dbf	d3,fix_chk_loop

; Remove start of name (a2 = original, a3 = original after subst-name)
	sub.w	d4,(a2)+		; remove length of stubst name
	sub.w	d4,d2
	bra.s	fix_up_start

fix_up_loop
	move.b	(a3)+,(a2)+
fix_up_start
	dbf	d2,fix_up_loop
	bra.s	io_rts
fix_err
	clr.l	(a2)			; clear name
	clr.l	-hdr.len(a1)		; clear file length
io_rts	move.l	(a7)+,d3
	rts

get_rename_name
	move.l	2(a1),d7
	andi.l	#$DFDFDF00,d7
	move.l	a1,-(a7)
	lea	iod_dnus(a3),a1
	move.l	2(a1),d6
	andi.l	#$DFDFDF00,d6
	movea.l (a7)+,a1
	cmp.l	d6,d7			; does device name match?
	  beq.s do_rename
	moveq	#err.inam,d0		; no... cannot rename
	rts

do_rename
	move.b	5(a1),d4		; drive number
	subi.b	#'0',d4
	move.l	a1,-(a7)
	lea	ddb_drv(a3),a1
	move.l	2(a1),d6
	lea	ddb_num(a3),a1
	move.b	(a1),d6
	movea.l (a7)+,a1
	addi.b	#'0',d6 		; CHN_DRV name
	move.l	d6,2(a1)
	bsr	get_use_name
	movem.l d1-d4/a0-a1,-(a7)
	movea.l a1,a0
	move.w	(a0)+,d1
	move.w	d1,d3
	subq.w	#5,d1
	move.w	(a4),d2
	tst.w	d2
	  beq.s rn_rts
	add.w	d2,d3
	cmpi.w	#hdr.nmln,d3
	  bhi.s rn_ipar 		; resulting filename too big
	bra.s	L0402

L03F8	move.w	d2,d4
	add.w	d1,d4
	move.b	5(a0,d1.w),5(a0,d4.w)
L0402	dbf	d1,L03F8
	move.w	(a4)+,d2
	move.w	d3,(a1)+
	lea	5(a1),a1
	bra.s	L0412
L0410	move.b	(a4)+,(a1)+
L0412	dbf	d2,L0410
	bra.s	rn_rts

rn_ipar moveq	#err.ipar,d0
rn_rts	movem.l (a7)+,d1-d4/a0-a1
	rts

; ***** Close routine
close	move.l	a0,-(a7)
	movea.l sub_cid(a0),a0
	moveq	#ioa.clos,d0
	trap	#2
	movea.l (a7),a0
	moveq	#0,d0
	move.b	$001D(a0),d0
	lsl.w	#2,d0
	lea	$0100(a6),a2
	movea.l $00(a2,d0.w),a2
	subq.b	#$01,$0022(a2)
	lea	$0018(a0),a0
	lea	$0140(a6),a1
	movea.w mem.rlst,a2
	jsr	(a2)
	movea.l (a7)+,a0
	movea.w mem.rchp,a2
	jmp	(a2)
	moveq	#err.ipar,d0
	rts

; ***** Format routine
format	moveq	#err.nimp,d0
	rts

; ***** Open routine
open	move.b	iod_dnum(a1),d4 	; SUB drive number
	move.b	d4,sub_num(a0)		; remember it
	cmpi.b	#ioa.kdir,chn_accs(a0)	; read from directory?
	seq	sub_dir(a0)		; remember this
	lea	ddb_drv(a3),a2		; SUB_DRV name
	move.l	2(a2),d6
	andi.l	#$DFDFDF00,d6
	lea	ddb_num(a3),a2		; SUB_DRV number
	move.b	(a2),d6
	addi.b	#'0',d6 		; combined name and number
	lea	sub_nam(a0),a2
	move.l	d6,(a2)+		; start with SUB_DRV name
	move.b	#'_',(a2)+
	bsr.s	get_use_name
	move.w	(a4)+,d0
	  beq.s no_use
	bra.s	cp_use1

cp_use	move.b	(a4)+,(a2)+		; copy SUB_USE name
cp_use1 dbf	d0,cp_use

no_use	lea	chn_name(a0),a1
	move.w	(a1)+,d0
	bra.s	cp_nme1

cp_nme	move.b	(a1)+,(a2)+		; copy filename
cp_nme1 dbf	d0,cp_nme

	movea.l sys_chtb(a6),a1
chtb_scan
	tst.l	(a1)+			; scan for next free space in table
	  bpl.s chtb_scan		; +ve = occupied
	clr.l	-(a1)			; reserve space in list?
	move.l	a1,-(a7)
	moveq	#ioa.open,d0
	moveq	#-1,d1
	move.b	chn_accs(a0),d3
	  bge.s no_delete
	moveq	#ioa.delf,d0
no_delete
	move.l	a0,-(a7)
	lea	sub_nam(a0),a0
	suba.l	a0,a2			; string length
	move.w	a2,-(a0)		; put in front of name
	trap	#2			; pass new name to real open routine
	movea.l a0,a2
	movea.l (a7)+,a0		; get our CDB back
	movea.l (a7)+,a1
	st	(a1)			; mark ct entry empty again probably
					; so that our channel ends up here
	move.l	a2,sub_cid(a0)		; remember channel ID
	rts

; d4 = drive number
; a4 = "use" name for drive
get_use_name
	clr.w	d5
	move.b	d4,d5
	lea	ddb_dr1(a3),a4
	cmpi.b	#8,d5
	  bhi.s L04FC
	subq.b	#1,d5
	  bmi.s L04FC
	bra.s	L04F8
L04F4	lea	ddb.drx(a4),a4		; skip to next name
L04F8	dbf	d5,L04F4
L04FC	rts

;	Config Post-processing Routine
L04FE	lea	4(a0),a0
	move.l	(a0),d1
	andi.l	#$DFDFDF00,d1
	move.b	#'0',d1
	move.l	d1,(a0)
	clr.l	d1
	clr.l	d0
	rts

;	Config Post-processing Routine
L0516	move.w	2(a0),d1
	cmpi.b	#'_',3(a0,d1.w)
	  bne.s L0524
	bra.s	L0538
L0524	cmp.w	(a0),d1
	  bne.s L052E
	moveq	#0,d1
	moveq	#err.ipar,d0
	rts

L052E	move.b	#'_',4(a0,d1.w)
	addq.w	#1,2(a0)
L0538	moveq	#0,d1
	moveq	#0,d0
	rts

;	Config Block Header
	dc.b	'<<QCFX>>01'
	dc.w	$14
	dc.b	'SUB_Directory_Device'
	dc.w	4
	dc.b	'0.06'

	dc.b	0,'S'
	dc.w	L0894-*
	dc.w	0
	dc.w	L04FE-*
	dc.w	L05EA-*
	dc.w	0

	dc.b	0,'U'
	dc.w	L089E-*
	dc.w	0
	dc.w	L04FE-*
	dc.w	L0600-*
	dc.w	0

	dc.b	4,'N'
	dc.w	cf_num-*
	dc.w	0
	dc.w	0
	dc.w	L0626-*
	dc.w	L0652-*

	dc.b	0,'1'
	dc.w	cf_drv1-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L0684-*
	dc.w	0

	dc.b	0,'2'
	dc.w	cf_drv2-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L069E-*
	dc.w	0

	dc.b	0,'3'
	dc.w	cf_drv3-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L06B8-*
	dc.w	0

	dc.b	0,'4'
	dc.w	cf_drv4-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L06D2-*
	dc.w	0

	dc.b	0,'5'
	dc.w	cf_drv5-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L06EC-*
	dc.w	0

	dc.b	0,'6'
	dc.w	cf_drv6-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L0706-*
	dc.w	0

	dc.b	0,'7'
	dc.w	cf_drv7-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L0720-*
	dc.w	0

	dc.b	0,'8'
	dc.w	cf_drv8-*
	dc.w	0
	dc.w	L0516-*
	dc.w	L073A-*
	dc.w	0
	dc.w	-1

L05EA	dc.w	19
	dc.b	'Name this of driver',0
L0600	dc.w	35
	dc.b	'Device sub-directories are found on',0
L0626	dc.w	41
	dc.b	'Drive number sub-directories are found on',0

L0652	dc.b	1,0
	dc.w	1
	dc.b	'1',0
	dc.b	2,0
	dc.w	1
	dc.b	'2',0
	dc.b	3,0
	dc.w	1
	dc.b	'3',0
	dc.b	4,0
	dc.w	1
	dc.b	'4',0
	dc.b	5,0
	dc.w	1
	dc.b	'5',0
	dc.b	6,0
	dc.w	1
	dc.b	'6',0
	dc.b	7,0
	dc.w	1
	dc.b	'7',0
	dc.b	8,0
	dc.w	1
	dc.b	'8',0
	dc.w	-1

L0684	dc.w	23
	dc.b	'Default sub-directory 1',0
L069E	dc.w	23
	dc.b	'Default sub-directory 2',0
L06B8	dc.w	23
	dc.b	'Default sub-directory 3',0
L06D2	dc.w	23
	dc.b	'Default sub-directory 4',0
L06EC	dc.w	23
	dc.b	'Default sub-directory 5',0
L0706	dc.w	23
	dc.b	'Default sub-directory 6',0
L0720	dc.w	23
	dc.b	'Default sub-directory 7',0
L073A	dc.w	23
	dc.b	'Default sub-directory 8'

cf_num	dc.b	1

cf_drv1 dc.w	35
	dc.w	5
	dc.b	'work_'
	ds.b	31
cf_drv2 dc.w	35
	dc.w	8
	dc.b	'q_mship_'
	ds.b	28
cf_drv3 dc.w	35
	dc.w	8
	dc.b	'acc_win_'
	ds.b	28
cf_drv4 dc.w	35
	dc.w	8
	dc.b	'bas_prg_'
	ds.b	28
cf_drv5 dc.w	35
	dc.w	8
	dc.b	'bas_obj_'
	ds.b	28
cf_drv6 dc.w	35
	dc.w	8
	dc.b	'psi_doc_'
	ds.b	28
cf_drv7 dc.w	35
	dc.w	11
	dc.b	'wp_87_text_'
	ds.b	25
cf_drv8 dc.w	35
	dc.w	5
	dc.b	'temp_'
	ds.b	31

L0894	dc.w	4

L0896	dc.w	3
	dc.b	'SUB',0
	dc.w	0
										
L089E	dc.w	4
cf_drv	dc.w	3
	dc.b	'WIN',0
	dc.w	0

ut_gtnam
	tst.w	2(a6,a3.l)		; is there a name?
	  bmi.s ut_gtnst		; ... no, always get string
	moveq	#$f,d0			; extract type of name
	and.b	1(a6,a3.l),d0
	subq.b	#1,d0			; is it a string?
	  bne.s ut_gnmpt		; ... no, get the name instead
ut_gtnst
	move.l	a5,-(a7)
	lea	8(a3),a5
	movea.w sb.gtstr,a2
	jsr	(a2)
	movea.l (a7)+,a5
	  bne.s utgn_rts
	moveq	#3,d1
	add.w	(a6,a1.l),d1
	bclr	#0,d1
	add.l	d1,sb_arthp(a6)
	bra.s	utgn_ok

ut_gnmpt
	moveq	#err.ipar,d0
	moveq	#0,d1
	move.w	2(a6,a3.l),d1		; get the pointer to the real entry
	  bmi.s utgn_rts		; ... expression is no good
	lsl.l	#3,d1			: in multiples of 8 bytes
	add.l	sb_nmtbb(a6),d1
	moveq	#0,d6
	move.w	2(a6,d1.l),d6		; thus the pointer to the name
	add.l	sb_nmlsb(a6),d6
	moveq	#0,d1
	move.b	(a6,d6.l),d1
	addq.l	#1,d1
	bclr	#0,d1			; rounded up
	move.w	d1,d4
	addq.l	#2,d1			; +2
	movea.w qa.resri,a2
	jsr	(a2)
	movea.l sb_arthp(a6),a1
	add.w	d4,d6			; move to end of string (ish)
ut_nam_loop
	subq.l	#1,a1
	move.b	(a6,d6.l),(a6,a1.l)
	subq.l	#1,d6
	dbf	d4,ut_nam_loop
	subq.l	#1,a1
	clr.b	(a6,a1.l)
utgn_ok
	moveq	#0,d0
utgn_rts
	rts

	end
